#include "M451Series.h"
#include "IOI2C.h"
#include "SysTick.h"
#define u8 uint8_t
typedef unsigned char  uchar;
typedef unsigned short ushort;
typedef unsigned int   uint;
/*******************************************************************************
*          : IIC_Init
* 		 : ʼIIC
*            : 
*          	 : 
*******************************************************************************/
void IIC_Init(void)
{
	GPIO_SetMode(PF,BIT3|BIT4,GPIO_MODE_QUASI);
	IIC_SDA=1;
	IIC_SCL=1;
	delay_us(5);
}
/*******************************************************************************
*          : IIC_Start
* 		 : ʼź
*            : 
*          	 : 1
*******************************************************************************/
int IIC_Start(void)
{
    IIC_SDA = 1;  
	//if(!IIC_SDA) return 0;		
    IIC_SCL = 1;                   
    delay_us(5);                
    IIC_SDA = 0;  
	//if(IIC_SDA) return 0;		
    delay_us(5);                  
    IIC_SCL = 0;    
	return 1;
}
/*******************************************************************************
*          : IIC_Stop
* 		 : ֹź
*            : 
*          	 : 
*******************************************************************************/
void IIC_Stop(void)
{
	IIC_SCL = 0;
    IIC_SDA = 0;                    
    IIC_SCL = 1;                    
    delay_us(5);                 
    IIC_SDA = 1;                   
    delay_us(5);                  
}
/*******************************************************************************
*          : IIC_Ack
* 		 : Ӧ
*            : 
*          	 : 
*******************************************************************************/
void IIC_Ack(void)
{
	IIC_SCL = 0;
	delay_us(1);  
    IIC_SDA = 0;    
	delay_us(1);  	
    IIC_SCL = 1;                    
    delay_us(5);                  
    IIC_SCL = 0;                   
    delay_us(5);                  
}
/*******************************************************************************
*          : IIC_NAck
* 		 : Ӧ
*            : 
*          	 : 
*******************************************************************************/
void IIC_NAck(void)
{
	IIC_SCL = 0;
	delay_us(1);  
	IIC_SDA = 1;   
	delay_us(1);  	
    IIC_SCL = 1;                  
    delay_us(5);                  
    IIC_SCL = 0;                    
    delay_us(5);                 
}
/*******************************************************************************
*          : IIC_Wait_Ack
* 		 : ȴӦ
*            : 
*          	 : 10
*******************************************************************************/
char IIC_Wait_Ack(void)
{
	u8 ucErrTime=0;
	IIC_SDA = 1;
    IIC_SCL = 1;                   
    delay_us(5);                  
    while(IIC_SDA)
	{
		ucErrTime++;
		if(ucErrTime>225)
		{
			//IIC_Stop();
			IIC_SCL = 0; 
			return 1;
		}
		delay_us(5);
	}                 
    IIC_SCL = 0;                   
    delay_us(5);                
    return 1;
}
/*******************************************************************************
*          : IIC_Send_Byte
* 		 : һֽڵ
*            : com
*          	 : 
*******************************************************************************/
void IIC_Send_Byte(u8 dat)
{
    uchar i,CY;
	IIC_SCL = 0;
    for (i=0; i<8; i++)        
    {
		CY=(0x80 & dat)>>7;
        dat <<= 1;              
        IIC_SDA = CY;              
        IIC_SCL = 1;              
        delay_us(5);            
        IIC_SCL = 0;               
        delay_us(5);            
    }
	//IIC_Wait_Ack();
}
/*******************************************************************************
*          : IIC_Read_Byte
* 		 : ȡһֽڵ
*            : com
*          	 : õ
*******************************************************************************/
uint8_t IIC_Read_Byte(unsigned char ack)
{
    uchar i;
    uchar dat = 0;
    IIC_SDA = 1;                    
    for (i=0; i<8; i++)         
    {
		IIC_SCL=0; 
        dat <<= 1;
        IIC_SCL = 1;            
        delay_us(5);            
        dat |= IIC_SDA;            
        IIC_SCL = 0;               
        delay_us(5);              
    }
	if (ack)
        IIC_Ack(); //ACK 
    else
        IIC_NAck();//nACK  
    return dat;
}

int i2cWrite(uint8_t addr, uint8_t reg, uint8_t len, uint8_t *data)
{
	int i;
    if (!IIC_Start())
        return 1;                
    IIC_Send_Byte(addr<<1);   
	if (!IIC_Wait_Ack()) 
	{
        IIC_Stop();
        return 1;
    }
    IIC_Send_Byte(reg);    
	IIC_Wait_Ack();
    for (i = 0; i < len; i++) 
	{
        IIC_Send_Byte(data[i]);
		if (!IIC_Wait_Ack()) 
		{
			IIC_Stop();
			return 0;
		}
    }
    IIC_Stop();    
	return 0;
}

int i2cRead(uint8_t addr, uint8_t reg, uint8_t len, uint8_t *buf)
{
	if (!IIC_Start())
        return 1;
	IIC_Send_Byte(addr<<1);  
	if (!IIC_Wait_Ack()) 
	{
        IIC_Stop();
        return 1;
    }
	IIC_Send_Byte(reg);   
	IIC_Wait_Ack();
	IIC_Start();                   
	IIC_Send_Byte((addr<<1)+1); 
	IIC_Wait_Ack();
	while (len) 
	{
        if (len == 1)
            *buf = IIC_Read_Byte(0);
        else
            *buf = IIC_Read_Byte(1);
        buf++;
        len--;
    }                    
	IIC_Stop();  
	return 0;	
}
/**************************ʵֺ********************************************
ԭ:		unsigned char I2C_ReadOneByte(unsigned char I2C_Addr,unsigned char addr)
:	    ȡָ豸 ָĴһֵ
    :		I2C_Addr   Ŀ豸ַ
				addr	   Ĵַ
    :   	ֵ
*******************************************************************************/ 
unsigned char I2C_ReadOneByte(unsigned char I2C_Addr,unsigned char addr)
{
	unsigned char res=0;
	
	IIC_Start();	
	IIC_Send_Byte(I2C_Addr);	   //д
	res++;
	IIC_Wait_Ack();
	IIC_Send_Byte(addr); res++;  //͵ַ
	IIC_Wait_Ack();	  
	IIC_Start();
	IIC_Send_Byte(I2C_Addr+1); res++;          //ģʽ			   
	IIC_Wait_Ack();
	res=IIC_Read_Byte(0);	   
    IIC_Stop();//һֹͣ

	return res;
}
/**************************ʵֺ********************************************
ԭ:		u8 IICreadBytes(u8 dev, u8 reg, u8 length, u8 *data)
:	    ȡָ豸 ָĴ lengthֵ
    :		dev  		Ŀ豸ַ
				reg	  		Ĵַ
				length 		Ҫֽ
				*data  		ݽҪŵָ
    :   	ֽ
*******************************************************************************/ 
u8 	IICreadBytes(u8 dev, u8 reg, u8 length, u8 *data)
{
    u8 count = 0;
	
	IIC_Start();
	IIC_Send_Byte(dev);	   //д
	IIC_Wait_Ack();
	IIC_Send_Byte(reg);   //͵ַ
    IIC_Wait_Ack();	  
	IIC_Start();
	IIC_Send_Byte(dev+1);  //ģʽ	
	IIC_Wait_Ack();
	
    for(count=0;count<length;count++)
	{
		 
		 if(count!=length-1)	data[count]=IIC_Read_Byte(1);  //ACKĶ
		 else  data[count]=IIC_Read_Byte(0);	 //һֽNACK
	}
    IIC_Stop();//һֹͣ
    return count;
}
/**************************ʵֺ********************************************
ԭ:		u8 IICwriteBytes(u8 dev, u8 reg, u8 length, u8* data)
:	    ֽдָ豸 ָĴ
    :		dev  		Ŀ豸ַ
				reg	  		Ĵַ
				length 		Ҫдֽ
				*data  		Ҫдݵ׵ַ
	  :   	Ƿɹ
*******************************************************************************/ 
u8 IICwriteBytes(u8 dev, u8 reg, u8 length, u8* data){
  
 	u8 count = 0;
	IIC_Start();
	IIC_Send_Byte(dev);	   //д
	IIC_Wait_Ack();
	IIC_Send_Byte(reg);   //͵ַ
    IIC_Wait_Ack();	  
	for(count=0;count<length;count++)
	{
		IIC_Send_Byte(data[count]); 
		IIC_Wait_Ack(); 
	}
	IIC_Stop();//һֹͣ

    return 1; //status == 0;
}
/**************************ʵֺ********************************************
ԭ:		u8 IICreadByte(u8 dev, u8 reg, u8 *data)
:	    ȡָ豸 ָĴһֵ
    :		dev  Ŀ豸ַ
				reg	   Ĵַ
				*data  ݽҪŵĵַ
    :  		1
*******************************************************************************/ 
u8 IICreadByte(u8 dev, u8 reg, u8 *data)
{
	*data=I2C_ReadOneByte(dev, reg);
    return 1;
}

/**************************ʵֺ********************************************
ԭ:		unsigned char IICwriteByte(unsigned char dev, unsigned char reg, unsigned char data)
:	    дָ豸 ָĴһֽ
    :		dev    Ŀ豸ַ
				reg	   Ĵַ
				data   Ҫдֽ
    :   	1
*******************************************************************************/ 
unsigned char IICwriteByte(unsigned char dev, unsigned char reg, unsigned char data)
{
    return IICwriteBytes(dev, reg, 1, &data);
}

/**************************ʵֺ********************************************
ԭ:		u8 IICwriteBits(u8 dev,u8 reg,u8 bitStart,u8 length,u8 data)
:	     ޸ д ָ豸 ָĴһֽ еĶλ
    :		dev  		Ŀ豸ַ
				reg	   		Ĵַ
				bitStart  	Ŀֽڵʼλ
				length   	λ
				data    	ŸıĿֽλֵ
    :   	ɹ Ϊ1 
				ʧ Ϊ0
*******************************************************************************/ 
u8 IICwriteBits(u8 dev,u8 reg,u8 bitStart,u8 length,u8 data)
{

    u8 b;
    if (IICreadByte(dev, reg, &b) != 0) 
	{
        u8 mask = (0xFF << (bitStart + 1)) | 0xFF >> ((8 - bitStart) + length - 1);
        data <<= (8 - length);
        data >>= (7 - bitStart);
        b &= mask;
        b |= data;
        return IICwriteByte(dev, reg, b);
    } 
	else 
	{
        return 0;
    }
}

/**************************ʵֺ********************************************
ԭ:		u8 IICwriteBit(u8 dev, u8 reg, u8 bitNum, u8 data)
:	     ޸ д ָ豸 ָĴһֽ е1λ
    :	    dev      Ŀ豸ַ
		        reg	     Ĵַ
		        bitNum   Ҫ޸ĿֽڵbitNumλ
		        data     Ϊ0 ʱĿλ0 򽫱λ
    :       ɹ Ϊ1 
 		        ʧ Ϊ0
*******************************************************************************/ 
u8 IICwriteBit(u8 dev, u8 reg, u8 bitNum, u8 data)
{
    u8 b;
    IICreadByte(dev, reg, &b);
    b = (data != 0) ? (b | (1 << bitNum)) : (b & ~(1 << bitNum));
    return IICwriteByte(dev, reg, b);
}






