#include "uart0.h"
#include "M451Series.h"
#include "main.h"

void MY_UART_INIT(void)
{

    CLK_EnableModuleClock(UART0_MODULE);

    /* Select UART module clock source as HXT and UART module clock divider as 1 */
    CLK_SetModuleClock(UART0_MODULE, CLK_CLKSEL1_UARTSEL_HXT, CLK_CLKDIV0_UART(1));	
	 /* Set PD multi-function pins for UART0 RXD(PD.6) and TXD(PD.1) */
    SYS->GPD_MFPL &= ~(SYS_GPD_MFPL_PD6MFP_Msk | SYS_GPD_MFPL_PD1MFP_Msk);
    SYS->GPD_MFPL |= (SYS_GPD_MFPL_PD6MFP_UART0_RXD | SYS_GPD_MFPL_PD1MFP_UART0_TXD);
	/* Reset UART module */
    SYS_ResetModule(UART0_RST);

    /* Configure UART0 and set UART0 baud rate */
    UART_Open(UART0, 9600);
	
	UART_EnableInt(UART0, (UART_INTEN_RDAIEN_Msk));
	
	printf("uart initial is ok");//ʾ
}
void USART0_Send_char(uint8_t c)
{
	  
	UART0->DAT = (uint8_t) c;    
	while((UART0->FIFOSTS & (1<<22)) ==0 );//ѭ,ֱ 	
	
} 
void UART0_IRQHandler(void)
{
	uint32_t u32IntSts = UART0->INTSTS;
	unsigned char nn;
    if(u32IntSts & UART_INTSTS_RDAINT_Msk)
	{
		nn=UART_READ(UART0);//PC˷ָ ж
		 if(nn=='f')//Сǰ˶
			{
				CAR_SPEED_SETfDelta+=40;
			}
			
			else if(nn=='g')//С˶
			{
				CAR_SPEED_SETfDelta-=40;
			}
			else if(nn=='l')//Сֹ
			{
				CAR_SPEED_SETfDelta=0;
			}
			else if(nn == 'm')//Сת
			{
				g_sTurn_Lift = 900;
				g_sTurn_Right = -300;
			}
			else if(nn=='n')//Сת
			{
				g_sTurn_Right = 1000;
			}
			else if(nn=='o')//ֹͣת
			{
				g_sTurn_Right = g_sTurn_Lift = 0;
				g_fSpeedControlIntegral = 0;
			}
		}
		
}
